﻿using System;
using System.Collections.Generic;
using System.Data;
using Visitas.Classes;
using Newtonsoft.Json;
using System.Web.Security;
using System.Linq;
using System.Web.Services;
using System.Web.Script.Services;
using System.Web;
using System.Collections;
using Syncfusion.JavaScript.DataSources;
//using Telerik.Web.Data.Extensions;
using Syncfusion.Linq;


namespace Visitas
{
    public partial class VisitPool : System.Web.UI.Page
    {
        List<OpcionMenu> opcionesMenu = new List<OpcionMenu>();
        public static List<VisitData> LVisitas = null;
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                //DateTime minHour, maxHour;
                int UserType = Convert.ToInt32(Session["UserType"]);
                grdVisitPool.Columns[9].DateTimeEditOptions = new Syncfusion.JavaScript.Models.DateTimePickerProperties()
                { MinDateTime = RedondearHora(DateTime.Now).AddHours(2)
                , MaxDateTime = (DateTime.Now.AddDays(2)) };                
                //grdVisitPool.DataSource = LVisitas;
                //grdVisitPool.DataBind();

                if (UserType == 5)
                {
                    this.grdVisitPool.EditSettings.AllowEditing = true;
                    this.grdVisitPool.Columns[1].AllowEditing = false;
                    this.grdVisitPool.Columns[1].Visible = false;


                }
                btnAddNew.Attributes.Add("onClick", "return false;");
                try
                {
                    DataSet DSUserAccess = (DataSet)Session["DSUserAccess"];
                    DataTable tblMenuAgregar = DSUserAccess.Tables[0];
                    opcionesMenu = OpcionMenu.getMenuServiciosVisita(tblMenuAgregar);
                    Session["opcionesMenuStr"] = JsonConvert.SerializeObject(opcionesMenu);
                    /*variable de relleno*/
                    if (opcionesMenu.Count == 0)
                    {
                        btnAddNew.Visible = false;
                        UPBtnBar.Update();
                    }
                }
                catch
                {
                    FormsAuthentication.SignOut();
                    Response.Redirect("inicio.aspx");
                }
            }
        }


            private static DateTime RedondearHora(DateTime Hora)
            {
                int Min;
                Min = Convert.ToInt32(DateTime.Now.Minute.ToString());
                int suma = 60 - Min;
                int resta = 30 - Min;
                if (Min < 30)
                {
                
                    return Hora.AddMinutes(resta);
                }

                if (Min > 30)
                {
                
                return Hora.AddMinutes(suma);
                }
            Hora.AddHours(2);
            return Hora;
            }
  
        [WebMethod]
        [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
        public static object DataSource(Syncfusion.JavaScript.DataManager value)
        {
            IEnumerable data = BindGrid();
            DataOperations ds = new DataOperations();
            
            if (value.Where != null && value.Where.Count > 0) //Filtrado
            {
                data = ds.PerformWhereFilter(data, value.Where, value.Where[0].Operator);
            }
            if (value.Search != null && value.Search.Count > 0) // Busqueda
            {
                data = ds.PerformSearching(data, value.Search);
            }

            var count = data.AsQueryable().Count();
            if (value.Sorted != null && value.Sorted.Count > 0) //Ordenamiento
            {
                data = ds.PerformSorting(data, value.Sorted);
            }
            return new { result = data, count = count };
        }

        public static List<VisitData> BindGrid()
        { 
                LVisitas = new List<VisitData>();
                SW_CapturaWEB_CapturaService.CapturaService _lnvo_GetContainers = new SW_CapturaWEB_CapturaService.CapturaService();
                int UserId = Convert.ToInt32(HttpContext.Current.Session["UserId"]);
                DataTable Dt = _lnvo_GetContainers.GetVisitListForUserId(UserId);
                foreach (DataRow dr in Dt.Rows)
                {
                    LVisitas.Add(new VisitData
                    {
                        intVisitId = Convert.ToInt32(dr["intVisitId"]),
                        strCarrierLine = Convert.ToString(dr["strCarrierLine"]),
                        strVisitDriver = Convert.ToString(dr["strVisitDriver"]),
                        strVisitPlate = Convert.ToString(dr["strVisitPlate"]),
                        strVisitDriverLicenceNumber = Convert.ToString(dr["strVisitDriverLicenceNumber"]),
                        strService = Convert.ToString(dr["strService"]),
                        struserlastmodifiedby = Convert.ToString(dr["struserlastmodifiedby"]),
                        intCarrierLineId = Convert.ToInt32(dr["intCarrierLineId"]),
                        strServiceIdentifier = Convert.ToString(dr["strServiceIdentifier"]),                        
                        dtmAppointmentDate = Convert.ToDateTime(dr["dtmAppointmentDate"])
                    });
                }

            return LVisitas;
        }
        [WebMethod]
        [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
        public static void URLUpdate(VisitData value)
        {
            SW_CapturaWEB_CapturaService.CapturaService _lnvo_UpdateVisit = new SW_CapturaWEB_CapturaService.CapturaService();
            long Visita;
            string Transportista, Conductor, Placas, Licencia, Servicio, Usuario;
            int IDCarrier;
            DateTime dtmFecha;
            VisitData result = LVisitas.Where(o => o.intVisitId == value.intVisitId).FirstOrDefault();
            if (result != null)
            {
                {
                    result.intVisitId = value.intVisitId; Visita = result.intVisitId;
                    result.strCarrierLine = value.strCarrierLine; Transportista = result.strCarrierLine;
                    if (value.strVisitDriver != null) { result.strVisitDriver = value.strVisitDriver; Conductor = result.strVisitDriver.ToUpper(); }
                    else { result.strVisitDriver = value.strVisitDriver; Conductor = ""; }
                    if (value.strVisitPlate != null) { result.strVisitPlate = value.strVisitPlate; Placas = result.strVisitPlate.ToUpper(); }
                    else { result.strVisitPlate = value.strVisitPlate; Placas = ""; }
                    if (value.strVisitDriverLicenceNumber != null) { result.strVisitDriverLicenceNumber = value.strVisitDriverLicenceNumber; Licencia = result.strVisitDriverLicenceNumber.ToUpper(); }
                    else { result.strVisitDriverLicenceNumber = value.strVisitDriverLicenceNumber; Licencia = ""; }
                    result.strService = value.strService; Servicio = result.strService;
                    result.struserlastmodifiedby = Convert.ToString(HttpContext.Current.Session["strUserName"]); Usuario = result.struserlastmodifiedby;
                    result.intCarrierLineId = value.intCarrierLineId; IDCarrier = result.intCarrierLineId;
                    result.dtmAppointmentDate = value.dtmAppointmentDate; dtmFecha = result.dtmAppointmentDate;
                    _lnvo_UpdateVisit.UpdateVisitDriver(Visita, IDCarrier, Conductor, Placas, Licencia, Usuario, Convert.ToDateTime(dtmFecha));
                }
            }
        }

        [WebMethod]
        [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
        public static object UrlInsert(VisitData value)
        {
            LVisitas.Insert(0, value);
            return LVisitas;
        }

        [WebMethod]
        [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
        public static object GetCarriers(string strCarrierLine)
        {
            SW_CapturaWEB_CapturaService.CapturaService FillCarrier = new SW_CapturaWEB_CapturaService.CapturaService();
            DataTable dtCarrierList;
            List<string> lCarrierList = new List<string>(); 
            string strCarrierId = strCarrierLine.ToUpper();
            dtCarrierList = FillCarrier.SearchCarrieLike(strCarrierId);
            
            foreach (DataRow dr in dtCarrierList.Rows)
            {
               // string intcarrier = Convert.ToString(dr["intCarrierId"]);
                string strCarrier = Convert.ToString(dr["Nombre Transportista"]);
                lCarrierList.Add(strCarrier);

            }
            return lCarrierList.ToArray();
        }


        [Serializable]
        public class VisitData
        {
            public VisitData()
            {

            }
            public VisitData(long intVisitId, string strCarrierLine, string strVisitDriver, string strVisitPlate, string strVisitDriverLicenceNumber, string strService, string struserlastmodifiedby,
                int intCarrierLineId, string strServiceIdentifier, DateTime dtmAppointmentDate)
            {
                this.intVisitId = intVisitId;
                this.strCarrierLine = strCarrierLine;
                this.strVisitDriver = strVisitDriver;
                this.strVisitPlate = strVisitPlate;
                this.strVisitDriverLicenceNumber = strVisitDriverLicenceNumber;
                this.strService = strService;
                this.struserlastmodifiedby = struserlastmodifiedby;
                this.intCarrierLineId = intCarrierLineId;
                this.strServiceIdentifier = strServiceIdentifier;
                this.dtmAppointmentDate = dtmAppointmentDate;
            }
            public long intVisitId { get; set; }
            public string strCarrierLine { get; set; }
            public string strVisitDriver { get; set; }
            public string strVisitPlate { get; set; }
            public string strVisitDriverLicenceNumber { get; set; }
            public string strService { get; set; }
            public string struserlastmodifiedby { get; set; }
            public int intCarrierLineId { get; set; }
            public string strServiceIdentifier { get; set; }
            public DateTime dtmAppointmentDate { get; set; }
        }



        //[WebMethod] //estos metodos son para llenado y actualizado de batch(Excel)
        //[ScriptMethod(ResponseFormat = ResponseFormat.Json)]
        //public static void BatchUpdate(List<VisitData> changed)
        //{

        //    SW_CapturaWEB_CapturaService.CapturaService _lnvo_UpdateVisit = new SW_CapturaWEB_CapturaService.CapturaService();
        //    long Visita;
        //    string Transportista, Conductor, Placas, Licencia, Servicio, Usuario;
        //    int IDCarrier;
        //    DateTime dtmFecha;
        //    if (changed != null)
        //    {
        //        foreach (var temp in changed)
        //        {
        //            VisitData result = LVisitas.Where(o => o.intVisitId == temp.intVisitId).FirstOrDefault();
        //            if (result != null)
        //            {
        //                result.intVisitId = temp.intVisitId; Visita = result.intVisitId;
        //                result.strCarrierLine = temp.strCarrierLine; Transportista = result.strCarrierLine;
        //                result.strVisitDriver = temp.strVisitDriver; Conductor = result.strVisitDriver.ToUpper();
        //                result.strVisitPlate = temp.strVisitPlate; Placas = result.strVisitPlate.ToUpper();
        //                result.strVisitDriverLicenceNumber = temp.strVisitDriverLicenceNumber; Licencia = result.strVisitDriverLicenceNumber.ToUpper();
        //                result.strService = temp.strService;  Servicio = result.strService;
        //                result.struserlastmodifiedby = Convert.ToString(HttpContext.Current.Session["strUserName"]); Usuario = result.struserlastmodifiedby;
        //                result.intCarrierLineId = temp.intCarrierLineId; IDCarrier = result.intCarrierLineId;

        //                result.dtmAppointmentDate = temp.dtmAppointmentDate; dtmFecha = result.dtmAppointmentDate;
        //                _lnvo_UpdateVisit.UpdateVisitDriver(Visita, IDCarrier, Conductor, Placas, Licencia, Usuario, Convert.ToDateTime(dtmFecha));

        //            }
        //         }
        //     }
        //}

        //protected void grdVisitPool_ServerEditRow(object sender, GridEventArgs e)
        //{
        //    EditAction(e.EventType, e.Arguments["data"]);
        //}
        //protected void EditAction(string eventType, object record)
        //{
        //    SW_CapturaWEB_CapturaService.CapturaService _lnvo_UpdateVisit = new SW_CapturaWEB_CapturaService.CapturaService();
        //    List<VisitData> data = Session["dtVisitPool"] as List<VisitData>;
        //    Dictionary<string, object> KeyVal = record as Dictionary<string, object>;
        //    if (eventType == "endEdit")
        //    {
        //        VisitData value = new VisitData();
        //        foreach (KeyValuePair<string, object> keyval in KeyVal)
        //        {
        //            if (keyval.Key == "intVisitId")
        //            {                        //value = data.Where(d => d.intVisitId == (long)keyval.Value).FirstOrDefault();
        //                value.intVisitId = Convert.ToInt32(keyval.Value);
        //            }
        //            else if (keyval.Key == "strCarrierLine")
        //            {
        //                value.strCarrierLine = Convert.ToString(keyval.Value);
        //            }
        //            else if (keyval.Key == "strVisitDriver")
        //            {
        //                value.strVisitDriver = Convert.ToString(keyval.Value);
        //            }
        //            else if (keyval.Key == "strVisitPlate")
        //            {
        //                value.strVisitPlate = Convert.ToString(keyval.Value);
        //            }
        //            else if (keyval.Key == "strVisitDriverLicenceNumber")
        //            {
        //                value.strVisitDriverLicenceNumber = Convert.ToString(keyval.Value);
        //            }
        //            else if (keyval.Key == "strService")
        //            {
        //                value.strService = Convert.ToString(keyval.Value);
        //            }
        //            else if (keyval.Key == "struserlastmodifiedby")
        //            {
        //                value.struserlastmodifiedby = Convert.ToString(Session["strUserName"]);
        //            }
        //            else if (keyval.Key == "intCarrierLineId")
        //            {
        //                value.intCarrierLineId = Convert.ToInt32(keyval.Value);
        //            }
        //            else if (keyval.Key == "dtmAppointmentDate")
        //            {
        //                value.dtmAppointmentDate = Convert.ToDateTime(keyval.Value);
        //            }
        //        }
        //        long Visita = value.intVisitId; string Transportista = value.strCarrierLine;
        //        string Conductor = value.strVisitDriver.ToUpper(); string Licencia = value.strVisitDriverLicenceNumber.ToUpper();
        //        string Placas = value.strVisitPlate.ToUpper();
        //        string Servicio = value.strService; string Usuario = value.struserlastmodifiedby;
        //        int IDCarrier = value.intCarrierLineId;
        //        DateTime dtmFecha = value.dtmAppointmentDate;
        //        _lnvo_UpdateVisit.UpdateVisitDriver(Visita, IDCarrier, Conductor, Placas, Licencia, Usuario, Convert.ToDateTime(dtmFecha));
        //    }
        //    //BindGrid();
        //    //Session["dtVisitPool"] = data;
        //    //this.grdVisitPool.DataSource = data;
        //    //this.grdVisitPool.DataBind();
        //}
    }
}